%# BEGIN BPS TAGGED BLOCK {{{
%#
%# COPYRIGHT:
%#
%# This software is Copyright (c) 1996-2023 Best Practical Solutions, LLC
%#                                          <sales@bestpractical.com>
%#
%# (Except where explicitly superseded by other copyright notices)
%#
%#
%# LICENSE:
%#
%# This work is made available to you under the terms of Version 2 of
%# the GNU General Public License. A copy of that license should have
%# been provided with this software, but in any event can be snarfed
%# from www.gnu.org.
%#
%# This work is distributed in the hope that it will be useful, but
%# WITHOUT ANY WARRANTY; without even the implied warranty of
%# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%# General Public License for more details.
%#
%# You should have received a copy of the GNU General Public License
%# along with this program; if not, write to the Free Software
%# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
%# 02110-1301 or visit their web page on the internet at
%# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html.
%#
%#
%# CONTRIBUTION SUBMISSION POLICY:
%#
%# (The following paragraph is not intended to limit the rights granted
%# to you to modify and distribute this software under the terms of
%# the GNU General Public License and is only of importance to you if
%# you choose to contribute your changes and enhancements to the
%# community by submitting them to Best Practical Solutions, LLC.)
%#
%# By intentionally submitting any modifications, corrections or
%# derivatives to this work, or any other work intended for use with
%# Request Tracker, to Best Practical Solutions, LLC, you confirm that
%# you are the copyright holder for those contributions and you grant
%# Best Practical Solutions,  LLC a nonexclusive, worldwide, irrevocable,
%# royalty-free, perpetual, license to use, copy, create derivative
%# works based on those contributions, and sublicense and distribute
%# those contributions and any derivatives thereof.
%#
%# END BPS TAGGED BLOCK }}}
<& /Elements/Header, Title => loc("Modify asset #[_1]: [_2]", $asset->id, $asset->Name) &>
<& /Elements/Tabs &>

<& /Elements/ListActions, actions => \@results &>

<span class="catalog <% CSSClass($asset->CatalogObj->Name) %>">
<form method="post" enctype="multipart/form-data" id="ModifyAsset" action="Modify.html">
  <input type="hidden" name="id" value="<% $asset->id %>">
  <input type="hidden" name="DisplayAfter" value="<% $DisplayAfter ? 1 : 0 %>">

  <&| /Widgets/TitleBox, title => loc("Basics"), class => "asset-basics", title_class => "inverse" &>
    <& Elements/EditBasics, %ARGS, AssetObj => $asset &>
  </&>

  <&| /Widgets/TitleBox, title => loc("Custom Fields"), class => "asset-info-cfs", title_class => "inverse" &>
    <& /Elements/EditCustomFields, Object => $asset, Grouping => '' &>
  </&>

  <& /Elements/Submit, Label => loc('Save asset'), Name => "Update" &>
</form>
</span>

<%args>
$id             => undef
$Update         => 0
$DisplayAfter   => 0
</%args>
<%init>
my $asset = LoadAsset($id);
my @results;

$m->callback( Asset => $asset, ARGSRef => \%ARGS, Update => \$Update, results => \@results );

if ($Update) {
    my $skip_update = 0;
    my @attributes  = $asset->WritableAttributes;

    # Don't update status unless we have a value; otherwise RT complains
    @attributes = grep { $_ ne "Status" } @attributes
        unless $ARGS{Status};

    my ($cf_ok, @cf_errors) = $m->comp(
        '/Elements/ValidateCustomFields',
        Object          => $asset,
        CustomFields    => $asset->CustomFields,
        ARGSRef         => \%ARGS
    );

    $m->callback(
        CallbackName        => 'BeforeUpdate',
        AssetObj            => $asset,
        UpdatableAttributes => \@attributes,
        results             => \@results,
        cf_ok               => \$cf_ok,
        skip_update         => \$skip_update,
        ARGSRef             => \%ARGS,
    );

    if ($cf_ok and not $skip_update) {
        push @results, ProcessObjectCustomFieldUpdates( Object => $asset, ARGSRef => \%ARGS );
        push @results, UpdateRecordObject(
            Object          => $asset,
            AttributesRef   => \@attributes,
            ARGSRef         => \%ARGS
        );

        $m->callback(
            CallbackName        => 'AfterUpdate',
            AssetObj            => $asset,
            UpdatableAttributes => \@attributes,
            results             => \@results,
            ARGSRef             => \%ARGS,
        );

        MaybeRedirectForResults(
            Actions     => \@results,
            Arguments   => { id => $asset->id },
            $DisplayAfter
                ? (Path => "/Asset/Display.html")
                : (),
        );
    } else {
        push @results, @cf_errors;
    }
}
</%init>
